local E, L, V, P, G = unpack(ElvUI);
local mPlugin = "mMediaTag"
local DT = E:GetModule("DataTexts");
local addon, ns = ...
local displayString = ""
local mText = L["Game Menu"]
local menuList = {}
local menuFrame = CreateFrame("Frame", "mSystemMenu", E.UIParent)
menuFrame:SetTemplate("Transparent", true)


local function mColor(color)
	local mSetting = E.db[mPlugin].mMenuColor 
	if mSetting then
		if color == 1 then
			return ns.mColor1
		elseif color == 2 then
			return ns.mColor2
		elseif color == 3 then
			return ns.mColor3
		elseif color == 4 then
			return ns.mColor4
		elseif color == 5 then
			return ns.mColor5
		elseif color == 6 then
			return ns.mColor6
		elseif color == 7 then
			return ns.mColor7
		end
	else
		return ns.mColor1
	end
end

local function Update(self, t)

end

local function OnEvent(self, event, ...)
	self.text:SetFormattedText(displayString, mText)
end

local function Click()
	menuList = {}
	menuList = {
		{text = mColor(2)  .. CHARACTER_BUTTON .. "|r", isTitle = false,
		func = function() ToggleCharacter("PaperDollFrame") end},
		{text = mColor(2)   .. SPELLBOOK_ABILITIES_BUTTON .. "|r", isTitle = false,
		func = function() if not SpellBookFrame:IsShown() then ShowUIPanel(SpellBookFrame) else HideUIPanel(SpellBookFrame) end end},
		{text = mColor(2)   .. TALENTS_BUTTON .. "|r", isTitle = false,
		func = function()
			if not PlayerTalentFrame then
				TalentFrame_LoadUI()
			end

			if not PlayerTalentFrame:IsShown() then
				ShowUIPanel(PlayerTalentFrame)
			else
				HideUIPanel(PlayerTalentFrame)
			end
		end},
		{text = mColor(2)   .. ACHIEVEMENT_BUTTON .. "|r", isTitle = false,
		func = function() ToggleAchievementFrame() end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = mColor(7)  .. GARRISON_LANDING_PAGE_TITLE .. "|r", isTitle = false,
		func = function() GarrisonLandingPageMinimapButton_OnClick() end},
		{text = mColor(7) .. COLLECTIONS .. "|r", isTitle = false,
		func = function()
			ToggleCollectionsJournal()
		end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = mColor(1) .. TIMEMANAGER_TITLE .. "|r", isTitle = false,
		func = function() ToggleFrame(TimeManagerFrame) end},
		{text = mColor(1) .. L["Calendar"] .. "|r", isTitle = false,
		func = function() GameTimeFrame:Click() end},

		{text = "", isTitle = true, func = function() end},
		
		{text = mColor(6) .. SOCIAL_BUTTON .. "|r", isTitle = false,
		func = function() ToggleFriendsFrame() end},
		{text = mColor(6) .. ACHIEVEMENTS_GUILD_TAB .. "|r", isTitle = false,
		func = function() ToggleGuildFrame() end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = mColor(7) .. LFG_TITLE .. "|r", isTitle = false,
		func = function() ToggleLFDParentFrame(); end},
		{text = mColor(7) .. ENCOUNTER_JOURNAL .. "|r", isTitle = false,
		func = function() if not IsAddOnLoaded("Blizzard_EncounterJournal") then EncounterJournal_LoadUI(); end ToggleFrame(EncounterJournal) end},
		
		{text = "", isTitle = true, func = function() end},
		
		
		{text = mColor(4) .. "ElvUI|r", isTitle = false,
		func = function() 
			if InCombatLockdown() then _G.UIErrorsFrame:AddMessage(E.InfoColor.._G.ERR_NOT_IN_COMBAT) return end
			E:ToggleOptionsUI()
		end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = mColor(1) .. MAINMENU_BUTTON .. "|r", isTitle = false,
		func = function()
			if ( not GameMenuFrame:IsShown() ) then
				if ( VideoOptionsFrame:IsShown() ) then
					VideoOptionsFrameCancel:Click();
				elseif ( AudioOptionsFrame:IsShown() ) then
					AudioOptionsFrameCancel:Click();
				elseif ( InterfaceOptionsFrame:IsShown() ) then
					InterfaceOptionsFrameCancel:Click();
				end
				CloseMenus();
				CloseAllWindows()
				ShowUIPanel(GameMenuFrame);
			else
				HideUIPanel(GameMenuFrame);
				MainMenuMicroButton_SetNormal();
			end
		end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = mColor(5) .. BLIZZARD_STORE .. "|r", isTitle = false, func = function() StoreMicroButton:Click() end},
		{text = mColor(5) .. HELP_BUTTON .. "|r", isTitle = false, func = function() ToggleHelpFrame() end}
	}
	mDropDown(menuList, menuFrame, E.db[mPlugin].mMenuUp, 160)
end

local function OnEnter(self)
	DT:SetupTooltip(self)
	DT.tooltip:AddLine(mText)
	DT.tooltip:AddLine("   ")
	DT.tooltip:AddLine(ns.mName .. " - Ver. " .. ns.mVersion)
	DT.tooltip:Show()
end

local function OnLeave(self)
	DT.tooltip:Hide()
end

local function ValueColorUpdate(hex)
	displayString = strjoin("", hex, "%s|r")

	if lastPanel ~= nil then
		OnEvent(lastPanel, "ELVUI_COLOR_UPDATE")
	end
end
E.valueColorUpdateFuncs[ValueColorUpdate] = true

DT:RegisterDatatext("Game Menu", {"PLAYER_ENTERING_WORLD"}, OnEvent, Update, Click, OnEnter, OnLeave, mText)